; 
    include \masm32\include\masm32rt.inc
    .586			
	include \masm32\macros\timers.asm

; 
.data
align 16
Tables       dd LeapDays, NonLeapDays, LeapDays, NonLeapDays
NonLeapDays  db 0, 0, 1fh, 0, 3bh, 0, 5ah, 0, 78h, 0, 97h, 0, 0b5h, 0, 0d4h, 0, 0f3h, 0, 11h,1, 30h, 1, 4eh, 1, 6dh, 1
NonLeapMonth db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ; 31->Jan 
db  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1              ; 28->Feb
db  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2   ; 31->March
db  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3       ; 30->April
db  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4   ; 31->May 
db  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5       ; 30->June
db  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6   ; 31->July  
db  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7   ; 31->August 
db  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8       ; 30->Sept
db  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9   ; 31->Oct
db  0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah         ;30->Nov
db  0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh  ;31->Dec
LeapDays  db  0, 0, 1fh, 0, 3ch, 0, 5bh, 0, 79h, 0, 98h, 0, 0b6h, 0, 0d5h, 0, 0f4h, 0, 12h,1, 31h, 1, 4fh, 1, 6eh, 1
LeapMonth db  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ; 31->Jan 
db  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1          ; 29->Feb
db  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2   ; 31->March
db  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3       ; 30->April
db  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4   ; 31->May 
db  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5       ; 30->June
db  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6   ; 31->July  
db  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7   ; 31->August 
db  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8       ; 30->Sept
db  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9   ; 31->Oct
db  0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah        ;30->Nov
db  0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh,0bh ;31->Dec

align 16
filetime1   FILETIME       <5F3F8FE0h,01C87A07h >
systime1   SYSTEMTIME < >

.code
option prologue:none
option epilogue:none  
align  16    
FileTimeToSystemTimeL  proc  lpFileTime:dword, lpSystemTime:dword
 mov   ecx, [esp+1*4] 
 mov   eax, 0E219652Ch 
 mov   [esp+1*4], edi 
 sub    esp, 4*4 
 mov   edi, [ecx].FILETIME.dwLowDateTime 
 mul    edi  
 mov   [esp+1*4], esi 
 mov   esi, [ecx].FILETIME.dwHighDateTime 
 mov   ecx, edx 
 mov   eax, 0E219652Ch 
 mul    esi  
 mov   [esp+2*4], ebp 
 mov   ebp, eax 
 mov   eax, edi 
 mov   edi, edx 
 mov   edx, 0D1B71758h 
 mul    edx  
 mov   [esp+3*4], ebx 
 xor     ebx, ebx 
 add    eax, ecx 
 adc    ebx, 0 
 add    eax, ebp 
 adc    ebx, 0 
 mov   ebp, edx 
 mov   eax, 0D1B71758h 
 mul    esi  
 add    eax, ebp 
 adc    edx, 0 
 add    eax, edi 
 adc    edx, 0 
 add    eax, ebx 
 adc    edx, 0 
 mov   edi, eax 
 mov   esi, edx 
 shrd   edi, edx, 13 
 mov   eax, 0FA67B90Eh 
 mul    edi  
 shr     esi, 13 
 mov   ebx, edx 
 mov   eax, 0FA67B90Eh 
 mul    esi  
 mov   [esp], edi 
 mov   ebp, eax 
 mov   ecx, edx 
 mov   eax, 0C6D750EBh 
 mul   edi  
 xor   edi, edi 
 add   eax, ebx 
 adc   edi, 0 
 add   eax, ebp 
 adc   edi, 0 
 mov  ebp, edx 
 mov   eax, 0C6D750EBh 
 mul   esi  
 mov   ebx, 5265C00h 
 add   eax, ebp 
 adc   edx, 0 
 add   eax, ecx 
 adc   edx, 0 
 add   eax, edi 
 adc   edx, 0 
 shrd  eax, edx, 1Ah 
 mov  ebp, eax 
 mul   ebx  
 sub   [esp], eax 
 mov  eax, 0B36D8398h 
 mul  ebp  
 shr   edx, 8 
 mov  ebx,edx 
GetD:
 mov  eax, 28F5C29h 
 mul   ebx  
 mov   esi, ebp 
 mov   ecx, ebx 
 lea    eax, [ebx+ebx*8] 
 add   esi, edx 
 shr   edx, 2 
 lea   eax, [ebx+eax*8] 
 sub   esi, edx 
 shr    ecx, 2 
 lea    eax, [eax+eax*4] 
 sub   esi, ecx 
 lea    ecx, [ebx+1] 
 sub    esi, eax 
 mov   eax, 28F5C29h  
 mul   ecx                                    
 lea    eax, [edx+edx*4] 
 lea    eax, [eax+eax*4] 
 shl    eax, 2 
 sub   eax, ecx 
 neg   eax  
 sbb   edi, edi 
 shr   edx, 2 
 lea   eax, [edx+edx*4] 
 lea   eax, [eax+eax*4] 
 shl   eax, 4 
 sub   eax, ecx 
 and   ecx, 3
 neg   eax  
 sbb   eax, eax 
 add   edi, eax 
 neg   ecx  
 sbb   eax, eax 
 add   eax, edi 
 neg   eax  
 cmp   esi, 16Dh 
 mov   edi, [Tables+eax*4] 
 jnl   MoreD 
SetD:
 lea    ecx, [ebp+1] 
 mov  eax, 24924925h 
 mul   ecx  
 mov  ebp, [esp+2*4+4*4] 
 add   ebx, 641h 
 mov  eax, edx 
 shl    edx, 3 
 sub   edx, eax 
 movzx eax, byte ptr [edi+esi+1Ah] 
 sub    ecx, edx 
 movzx edx, word ptr [edi+eax*2] 
 add   eax, 1 
 mov  dword ptr [ebp].SYSTEMTIME.wYear,ebx 
 neg   edx  
 mov  dword ptr [ebp].SYSTEMTIME.wMonth, eax
 lea    edx, [edx+esi+1] 
 mov  ebx, [esp] 
 mov  eax, 83126E98h  
 mov  dword ptr [ebp].SYSTEMTIME.wDayOfWeek, ecx
 mov  dword ptr [ebp].SYSTEMTIME.wDay, edx 
 mul   ebx   
 mov  edi, [esp+1*4+4*4] 
 shr    edx, 9 
 mov  ecx, edx 
 lea   eax, [edx+edx*2] 
 shl   edx, 0Ah 
 shl   eax, 3 
 sub   edx, eax 
 mov  eax, 91A2B3C5h 
 sub   ebx, edx 
 mul   ecx  
 mov  esi, [esp+1*4] 
 shr    edx, 0Bh 
 mov  dword ptr [ebp].SYSTEMTIME. wHour, edx 
 lea   edx, [edx+8*edx] 
 lea   edx, [edx+4*edx] 
 mov  eax, 4444445h 
 lea   edx, [edx+4*edx] 
 shl    edx, 4  
 sub   ecx, edx 
 mul   ecx
 mov  [ebp].SYSTEMTIME.wMilliseconds, bx
 mov   eax, ebp
 mov   ebp, [esp+2*4]
 mov  dword ptr [eax].SYSTEMTIME. wMinute, edx
 lea    edx, [edx+edx*4]
 mov  ebx, [esp+3*4]
 lea    edx, [edx+edx*2]
 shl    edx, 2
 add   esp, 4*4
 sub   ecx, edx
 mov  [eax].SYSTEMTIME. wSecond, cx
 ret   2*4  
align  16      
MoreD:      
 mov   ecx, 1 
 je      @f
 sub   esi, 16Dh 
 add   ebx, ecx 
 test   eax, ecx  
 jne    GetD
 sub   esi, ecx
 jmp   GetD
align  16
@@:
 test  eax, ecx     
 je    @f  
@@1:
 sub   esi, 16Dh 
 add  ebx, ecx
 jne   GetD
@@:
 cmp  byte ptr [edi+esi+1Ah], 0Bh 
 jne   @@1
 je    SetD
FileTimeToSystemTimeL  endp 
option prologue:prologuedef 
option epilogue:epiloguedef 

; 
.data
align 16
;
bDayOfWeek      db 0
	                       db ' '
szMonth1	          dw 0
	                      db '/'
szDay1	              dw 0
	                      db '/'
szYear1              dw 0,0
                          db 20h
szHour1             dw 0
                          db ':'
szMinute1          dw 0
                          db ':'           		
szSecond1         dw 0
                          db '.'           
szMilseconds1   dw 0
                          db 0,0,0,0           
;
.code
option prologue:none				
option epilogue:none				
align 16						
FileTimeToSystemTimeLA  proc  lpFileTime:DWORD
	mov	ecx,	[esp+1*4]
	mov	eax,	0E219652Ch	
	mov	[esp+1*4], edi	
	sub  esp,	4*4	
	mov	edi,	[ecx].FILETIME.dwLowDateTime
	mul	edi
	mov	[esp+1*4], esi
	mov	esi,	[ecx].FILETIME.dwHighDateTime
	mov	ecx,  edx
	mov	eax,	0E219652Ch
	mul	esi	
	mov	[esp+2*4], ebp
	mov	ebp,	eax
	mov	eax, 	edi
	mov	edi,  	edx
	mov	edx,	0D1B71758h
	mul	edx		
	mov	[esp+3*4], ebx
	xor	ebx,	ebx	
	add	eax,	ecx	
	adc	ebx,	0	
	add	eax,	ebp	
	adc	ebx,	0	
	mov	ebp,	edx	
	mov	eax,	0D1B71758h	
	mul	esi		
	add	eax,	ebp	
	adc	edx,	0	
	add	eax,	edi	
	adc	edx,	0	
	add	eax,	ebx	
	adc	edx,	0	
	mov	edi,   eax	
	mov	esi, 	edx	
	shrd	edi,	edx, 13	
	mov	eax,	0FA67B90Eh  	
	mul	edi		
	shr	esi,	13	
	mov	ebx,	edx	
	mov	eax,	0FA67B90Eh	
	mul	esi		
	mov	[esp], edi	
	mov	ebp,	eax	
	mov	ecx,	edx	
	mov	eax,	0C6D750EBh
	mul	edi		
	xor	edi,	edi	
	add	eax,	ebx	
	adc	edi,	0	
	add	eax,	ebp	
	adc	edi,	0	
	mov	ebp,	edx	
	mov	eax,	0C6D750EBh
	mul	esi		
	mov	ebx,	5265C00h
	add	eax,	ebp	
	adc	edx,	0	
	add	eax,	ecx	
	adc	edx,	0	
	add	eax,	edi	
	adc	edx,	0	
	shrd	eax,	edx, 1Ah
	mov	ebp,	eax
	mul	ebx		
	sub	[esp], eax
	mov	eax,	 0B36D8398h
	mul	ebp		
	shr	edx,	8	
	mov 	ebx, 	edx	
GetDA:					
	mov	eax,	28F5C29h
	mul	ebx		
	mov	esi, 	ebp	
	mov	ecx,  ebx	
	lea	eax,	[ebx+ebx*8]
	add	esi,	edx	
	shr	edx,	2	
	lea	eax,	[ebx+eax*8]
	sub	esi,	edx	
	shr	ecx,	2	
	lea	eax,	[eax+eax*4]
	sub	esi,	ecx	
	lea	ecx,	[ebx+1]
	sub	esi,	eax	
	mov	eax, 	28F5C29h
	mul	ecx                                      
	lea	eax,	[edx+edx*4]	
	lea	eax,	[eax+eax*4]	
	shl	eax,	2	
	sub	eax,	ecx	
	neg	eax		
	sbb	edi,	edi	
	shr	edx,	2	
	lea	eax,	[edx+edx*4]
	lea	eax,	[eax+eax*4]
	shl	eax,	4	
	sub	eax, 	ecx	
	and	ecx,	3
	neg	eax		
	sbb	eax,	eax	
	add	edi,	eax	
	neg	ecx		
	sbb	eax,	eax	
	add	eax,	edi	
	neg	eax		
	cmp	esi,	16Dh	
	mov	edi,	[Tables+eax*4]
	jnl	MoreDA
SetDA:		
	add	ebp,1
	mov	eax,	24924925h
	mul	ebp				
	add	ebx,	641h	
	imul	ebx, 	ebx, 41894h		
	mov	ecx,	ebx
	shr	ebx,	1Ch
	and	ecx,	0FFFFFFFh
	mov	eax,	ebx
	lea	ecx,	[ecx+ecx*4]
	add	eax, 	3030h
	mov	ebx,	ecx
	and	ecx,	7FFFFFFh
	shr	ebx,	1Bh
	lea	ecx,	[ecx+ecx*4+0C0000000h]
	add	ah, 	bl
	mov	ebx,	ecx
	and	ecx,	3FFFFFFh
	shr	ebx,	1Ah
	lea	ecx,	[ecx+ecx*4+60000000h]
	mov	word ptr szYear1, ax
	mov	eax,	edx
	shr	ecx,	19h
	shl	edx,	3
	mov	bh, 	cl
	sub	edx,	eax		
	mov	word ptr szYear1+2, bx
	movzx	eax,	byte ptr [edi+esi+1Ah]
	sub	ebp,  edx
	lea	ecx, 	[ebp+30h]
	movzx	edx,	word ptr [edi+eax*2]
	add	eax,	1
	imul	eax,	eax, 6666D8h 		
	mov	bDayOfWeek, cl
	mov	ecx, 	03FFFFFFh
	and	ecx, 	eax
	shr	eax, 	1Ah		
	lea	ecx, 	[ecx+ecx*4] 	
	add	eax, 	3030h
	shr	ecx, 	19h		
	neg	edx	
	add	ah,   	cl	
	lea	edx,	[edx+esi+1]
	mov	ecx, 	03FFFFFFh
	imul	edx,	edx, 6666D8h 		
	mov	word ptr szMonth1, ax
	and	ecx, 	edx
	shr	edx, 	1Ah	
	lea	ecx, 	[ecx+ecx*4] 	
	add	edx, 	3030h
	shr	ecx, 	19h	
	mov	ebx,	[esp]	
	add	dh,   	cl
	mov	word ptr szDay1, dx
	mov	eax,	83126E98h 
	mul	ebx 		
	mov	edi,	[esp+1*4+4*4] 	
	shr	edx,	9
	mov	ecx,	edx
	lea	eax,	[edx+edx*2]	
	shl	edx,	0Ah
	shl	eax,	3	
	sub	edx,	eax	
	sub	ebx,	edx	
	imul	ebx,	ebx, 147AE2h
	mov	eax,	7FFFFFFh	
	and	eax,	ebx
	shr	ebx,	1Bh	
	lea	eax,	[eax+eax*4]
	add	ebx,	3030h
	mov	edx,	eax
	and	eax,	3FFFFFFh
	shr	edx,	1Ah		
	lea	eax,	[eax+eax*4+60000000h] 
	add	bh,	dl 	
	shr	eax,	19h	
    mov byte  ptr szMilseconds1+2, al
	mov	eax,	91A2B3C5h	
	mul	ecx
	mov	word ptr szMilseconds1, bx
	shr	edx,	0Bh
	mov	ebx, 	edx
	imul	edx,	edx, 6666D8h 	
	mov	esi,	[esp+1*4]
	mov	eax, 	03FFFFFFh
	and	eax, 	edx
	shr	edx, 	1Ah
	lea	eax, 	[eax+eax*4]
	add	edx, 	3030h
	shr	eax, 	19h		
	add	dh,   	al	
	mov	word ptr szHour1, dx
	lea	edx,	[ebx+8*ebx]
	lea	edx,	[edx+4*edx]
	mov	eax,	4444445h	
	lea	edx,	[edx+4*edx]
	shl	edx,	4 
	sub	ecx,	edx
	mul	ecx
	mov	ebp,	[esp+2*4]
	mov	ebx, 	edx
	mov	eax, 	03FFFFFFh
	imul	edx,	edx, 6666D8h 		
	and	eax, 	edx
	shr	edx, 	1Ah
	lea	eax, 	[eax+eax*4]
	add	edx, 	3030h
	shr	eax, 	19h		
	add	dh,   	al	
	mov	word ptr szMinute1, dx
	lea	edx,	[ebx+ebx*4]
	mov	eax, 	03FFFFFFh
	lea	edx,	[edx+edx*2]
	shl	edx,	2
	sub	ecx,	edx
	imul	ecx,	ecx, 6666D8h 		
	mov	ebx,	[esp+3*4]
	add	esp,	4*4
	and	eax, 	ecx
	shr	ecx, 	1Ah
	lea	eax, 	[eax+eax*4]
	add	ecx, 	3030h
	shr	eax, 	19h		
	add	ch,   	al	
	mov	word ptr szSecond1, cx
	ret	1*4
align 16	
MoreDA:
	mov	ecx, 	1
	je	@f
	sub	esi,	16Dh	
	add 	ebx,	ecx	
	test	eax, 	ecx 	
	jne	GetDA
	sub	esi,	ecx
	jmp	GetDA
align 16
@@:
	test	eax,	ecx    	
	je	@f
@@1:
	sub	esi,	16Dh
	add 	ebx,	ecx
	jne	GetDA
@@:
	cmp	byte ptr [edi+esi+1Ah], 0Bh
	jne	@@1
	je	SetDA
FileTimeToSystemTimeLA  endp	
option prologue:prologuedef	
option epilogue:epiloguedef	





; 

; 

; 


.data
align 16
filetime2   FILETIME       <5F3F8FE0h,01C87A07h >
systime2   SYSTEMTIME < >

.code
; 
start:
; 
    ;function tests



    invoke Sleep, 3000

   counter_begin 1000, HIGH_PRIORITY_CLASS
     invoke	FileTimeToSystemTime, addr filetime2,addr systime2
      counter_end
    print ustr$(eax)," cycles, FileTimeToSystemTime-MS",13,10
   
    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	FileTimeToSystemTimeLA, addr filetime1
    counter_end
    print ustr$(eax)," cycles, FileTimeToSystemTimeLASCII-lingo",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	FileTimeToSystemTimeL, addr filetime1,addr systime1
    counter_end
    print ustr$(eax)," cycles, FileTimeToSystemTimeL-lingo",13,10

    inkey "Press any key to exit..."
    exit
; 
end start



